# PRACE CodeVault

PRACE CodeVault is an open repository containing various high
performance computing code samples. The project aims to support
self-learning of HPC programming and will be used as an Open platform
for the HPC community to share example code snippets, proof-of-concept
codes and so forth.  

CodeVault contains training material from PRACE partners, as well as
example codes of common HPC kernels such as dense and sparse linear
algebra, spectral and N-body methods, structured and unstructured
grids, Monte Carlo methods and parallel I/O. The code samples are
published as open source and can be used both for educational purposes
and as parts of real application suites (as permitted by particular
license).  

CodeVault consist of several Gitlab-projects which are organized into groups
and subgroups.


## HPC kernels

HPC kernels are under [hpc-kernels](https://repository.prace-ri.eu/git/CodeVault/hpc-kernels) group where each individual
kernel is a Gitlab project

 * [Dense linear algebra](https://repository.prace-ri.eu/git/CodeVault/hpc-kernels/dense_linear_algebra)
 * distributed_dense_linear_algebra
 * monte_carlo_methods
 * n-body_methods
 * parallel_io
 * sparse_linear_algebra
 * spectral_methods
 * structured_grids
 * unstructured_grids

## Training material

### Parallel programming

 * [MPI](https://repository.prace-ri.eu/git/CodeVault/training-material/MPI)
 * [OpenMP](https://repository.prace-ri.eu/git/CodeVault/training-material/OpenMP)
 * [Hybrid MPI/OpenMP](https://repository.prace-ri.eu/git/CodeVault/training-material/hybrid)

### GPU Programming
 * CUDA
 * OpenACC

### PGAS Languages

 * [Chapel](https://repository.prace-ri.eu/git/CodeVault/training-material/chapel)

### Python programming

 * Numerical and parallel programming
 * GPU programming

### Data processing

 * Python
 * R




Older test material



### MPI
[link to project/git repo](https://dummy) 1-line description of the content

[workshop1](https://workshops1) Introduction to MPI

[workshop2](https://workshops2) Intermediate course on MPI

[workshop3](https://workshops3) Advanced MPI workshop
###  OpenMP
[workshop1](https://workshops1)

[workshop2](https://workshops2)

[workshop3](https://workshops3)
### Python

## GPU_Programming
### CUDA
### GPU_Python
### OpenACC

## PGAS_Languages
### Chapel
### Coarray_Fortran

## Data_Processing
### Python
### R

## Debugging
### C
### Fortran
### Python

## Profiling
### C
### Fortran
### Python

## 07-Best_Practice_Guides
### C
### Fortran
### Python

## var
```